{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
unit FajlKez; {ltalnos fjlkezel szubrutinok}
interface
 uses Dos,StandDef,StandKom;

 function FajlVan(Fajl:PathStr):Boolean;
 {a Fajl fjl ltezik-e}

 procedure FajlTorol(Fajl:PathStr);
 {a Fajl fjlt trli, ha az ltezik}

 function FajlMeret(Fajl:PathStr):Longint;
 {az Fajl bjtjainak szma, nemltez fjlra 0 az rtk}

 function Egyseg(Spec:PathStr): Byte;
 {a Spec (fjl vagy knyvtr) specifikcibl meghatrozza az egysg
  sorszmt, ha nincs egysg megadva, akkor a fggvnyrtk=0 vagyis
  az aktulis egysg}

 const
  {hibakonstansok, a vgrehajts llapota}
  Rendben=0;
  InFajlHiba =1; { az input fjl nem elrhet, fjlspecifikcis hiba}
  OutFajlHiba=2; { az output fjl nem hozhat ltre,                 }
                 { knyvtr vagy fjlspecifikcis hiba              }
  OutKapHiba =3; { a kiirand informci nem fr el az egysgen      }
  InOutHiba  =4; { adattviteli (olvass s/vagy rs) hiba van      }

 const
  PufferMeret=2048;

 procedure FajlMasolo(Forras,             {i a msoland fjl      }
                      Cel     :PathStr;   {i a msolat fjl        }
                      var Hiba:Byte);     {o a vgrehajts llapota}

 { ha a Hiba>0, akkor msolat fjl nem keletkezik                  }

 type
  FajlAzon=string[12];

 procedure FajlKereso(Mit:FajlAzon;       {i a keresett fjl}
                      var Van:Boolean;    {o ltezse       }
                      var Hol:PathStr);   {o elrsi tja   }

 {Az aktulis egysgen az aktulis knyvtrbl kiindulva, a leszrmaztatott
  knyvtrakat is vgignzve keresi a Mit fjl els elfordulst. A keress
  a vgn a kiindulsi knyvtrba tr vissza}

 type
  FajlKit=string[3];

 function FajlValaszto(Kit: FajlKit;      {i a keresett kiterjeszts}
                       BFO,BFS: Byte;     {i a men bal fels sarka }
                       var Fajl:FajlAzon  {o a vlasztott fjl      }
                       ): Boolean;        {o trtnt-e vlaszts    }

 {Az aktulis knyvtrbl menszeren vlaszthatunk egyet a Kit kiterjeszts
  fjlazonostk kztt. A men mrete fix: 12 sor * 16 oszlopos tglalap, a
  megadott BFO (oszlop), BFS (sor) bal fels sarokkal                        }

implementation

 function FajlVan;
 var F:file;
 begin
  if Fajl='' then FajlVan:=False
  else begin
   Assign(F,Fajl);
   {$i-} Reset(F); {$i+}
   if IOResult=0 then begin
    FajlVan:=True; Close(F);
   end
   else FajlVan:=False;
  end;
 end;

 procedure FajlTorol;
 var F:file;
 begin
  if FajlVan(Fajl) then begin
   Assign(F,Fajl); Erase(F);
  end;
 end;

 function FajlMeret;
 var F:file;
 begin
  if not FajlVan(Fajl) then FajlMeret:=0
  else begin
   Assign(F,Fajl); Reset(F,1);
   FajlMeret:=FileSize(F); Close(F);
  end;
 end;

 function Egyseg;
 begin
  if (Length(Spec)<2) or (Spec[2]<>':') or
     not (UpCase(Spec[1]) in ['A'..'Z']) then Egyseg:=0
  else Egyseg:=Ord(UpCase(Spec[1]))-64;
 end;

 procedure FajlMasolo;
  var
   ForrF,CelF:file; Olvasott,Irt:0..PufferMeret;
   Puffer:array[1..PufferMeret] of Char;
 begin
  Hiba:=Rendben;
  if Forras<>Cel then begin
   Assign(ForrF,Forras);
   {$i-} Reset(ForrF,1); {$i+}
   if IOResult<>0 then Hiba:=InFajlHiba
   else begin
    Assign(CelF,Cel);
    {$i-} Rewrite(CelF,1); {$i+}
    if IOResult<>0 then Hiba:=OutFajlHiba
    else
    if DiskFree(Egyseg(Cel))<FileSize(ForrF) then Hiba:=OutKapHiba
    else begin
     repeat
      BlockRead(ForrF,Puffer,PufferMeret,Olvasott);
      BlockWrite(CelF,Puffer,Olvasott,Irt);
      if Irt<>Olvasott then Hiba:=InOutHiba;
     until (Olvasott=0) or (Hiba=InOutHiba);
     Close(CelF); if Hiba=InOutHiba then Erase(Celf);
    end;
    Close(ForrF);
   end
  end
 end;

 procedure FajlKereso;
  var
   Sr:SearchRec;
 begin
  Van:=FSearch(Mit,'')<>'';
  if Van then GetDir(0,Hol)
  else begin
   FindFirst('*.*',Directory,Sr);
   while not Van and (DosError=0) do begin
    if (Sr.Attr=Directory) and (Sr.Name[1]<>'.') then begin
     ChDir(Sr.Name);
     FajlKereso(Mit,Van,Hol);
     ChDir('..');
    end;
    if not Van then FindNext(Sr);
   end;
  end;
 end;

 function FajlValaszto;
  const
   EgyLap=MaxMenuSor-2;
  type
   FajlSorszam= 0..MaxLongint;
  var
   Fajlok: MenuSorok; v,k:MenuInd; Tol,j:FajlSorszam;
   Valasztott: Boolean;

  procedure BePakol;
   {Az aktulis knyvtr Kit kiterjeszts fjlazonostibl a knyvtron
    belli Tol -adikkal kezdve  Egylap db.-ot betesz a Fajlok tmb
    2..EgyLap+1 elemeibe. Ha a knyvtr vgig mr nincs ennyi, akkor a
    maradk tmbelemeket a - jellel tlti fel}
   var
    Sr:SearchRec; i:MenuInd;
  begin
   for i:=2 to EgyLap+1 do Fajlok[i]:='-';
   j:=0; i:=1;
   FindFirst('*.'+Kit,0,Sr);
   while (DosError=0) and (i<EgyLap+1) do begin
    Inc(j);
    if j>=Tol then begin
     Inc(i); Fajlok[i]:=Sr.Name;
    end;
    FindNext(Sr);
   end;
  end;{BePakol}

  begin
   Fajlok[0]:='Fjlok';
   Fajlok[1]:='-Elzk-'; Fajlok[MaxMenuSor]:='-Kvetkezk-';
   Tol:=1;
   repeat
    Bepakol; Valasztott:=False; k:=2;
    v:=AblMenu(Fajlok,MaxMenuSor,k,BFO,BFS, BFO+15,BFS+11);
    case v of
     1: if Tol-EgyLap<1 then Tol:=1 else Dec(Tol,EgyLap);
     2..EgyLap+1: Valasztott:= Fajlok[v][1]<>'-';
     MaxMenuSor : if Fajlok[EgyLap+1][1]<>'-' then Inc(Tol,EgyLap);
    end;
   until Valasztott or (v=0);
  FajlValaszto:=Valasztott;
  if Valasztott then Fajl:=fajlok[v];
 end;
end.
